# -*- coding: utf-8 -*-
"""
Created on Sat Mar 12 19:26:11 2022

@author: Fred
frederic.mandon@ac-montpellier.fr
Source principale :
https://stackoverflow.com/questions/49742217/python-socket-threading-tkinter-how-to-know()-the-message-sender
"""

#!/usr/bin/env python3
# -*- coding: utf-8 -*-

#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from datetime import datetime
from time import time
from random import shuffle, randint
from math import floor, exp, log
import socket
import threading
import tkinter as tk

regles_init_client = "Connectez-vous au serveur en donnant son IP"

regles_init_serveur = "Démarrez le serveur, et, à l'aide de l'invite de "
regles_init_serveur += "commandes, trouvez votre IP locale et donnez-la"
regles_init_serveur += "au joueur Client"

regles_connexion = "Etablissement de la connexion : triple poignée de main "
regles_connexion += "\nNotation des drapeaux :"
regles_connexion += "\n\tSYN pour synchronisation"
regles_connexion += "\n\tACK pour accusé de réception"
regles_connexion += "\n\tACQ pour acquittement"
regles_connexion += "\nLorsque la valeur d'un drapeau n'est pas précisée dans les règles ci-dessous,"
regles_connexion += "c'est le client ou le serveur qui la choisit."
regles_connexion += "\nDans ce jeu les valeurs données par les joueurs sont entre 100 et 900."
regles_connexion += "\n1 - Le client commence et envoie un drapeau SYN, avec un numéro x."
regles_connexion += "\n2 - Le serveur répond avec un drapeau ACK de valeur x + 1, et un drapeau SYN, avec un numéro y."
regles_connexion += "\n3 - Le client renvoie un drapeau ACQ de valeur x + 1 et un drapeau ACK de valeur y + 1."

regles_echange = "Echange de données : en trois étapes"
regles_echange += "\nNotation des drapeaux : "
regles_echange += "\n\tSEQ pour numéro de séquence"
regles_echange += "\n\tACK pour accusé de réception"
regles_echange += "\nLorsque la valeur d'un drapeau n'est pas précisée dans les règles ci-dessous,"
regles_echange += "c'est le client ou le serveur qui la choisit."
regles_echange += "\nDans ce jeu les valeurs données par les joueurs sont entre 100 et 900."
regles_echange += "\nLe numéro de séquence est choisi par le serveur uniquement lors du premier envoi, voir ci-dessous."
regles_echange += "\n1 - Le serveur envoie un drapeau SEQ avec le numéro de séquence, et un drapeau ACK de valeur y. Les données sont envoyées automatiquement avec."
regles_echange += "\n2 - Le client répond avec un drapeau SEQ de valeur y,"
regles_echange += "\tet un drapeau ACK de valeur égale au numéro de séquence + le nombre de caractères reçus."
regles_echange += "\n3 - Le serveur renvoie un drapeau SEQ de valeur égale au numéro de séquence + le nombre de caractères envoyés, "
regles_echange += "\n\tet un drapeau ACK de valeur égale au numéro de séquence + le nombre de caractères envoyés."

regles_fin = "Fin de la connexion : quadruple poignée de mains"
regles_fin += "\nNotation des drapeaux :"
regles_fin += "\n\tFIN pour demande de fin de connexion"
regles_fin += "\n\tACK pour accusé de réception"
regles_fin += "\nLorsque la valeur d'un drapeau n'est pas précisée dans les règles ci-dessous,"
regles_fin += "c'est le client ou le serveur qui la choisit."
regles_fin += "\nDans ce jeu les valeurs données par les joueurs sont entre 100 et 900."
regles_fin += "\n1 - Le client fait une demande de fin, avec un drapeau FIN et une valeur x."
regles_fin += "\n2 - Le serveur répond avec un drapeau ACK de valeur x + 1."
regles_fin += "\n3 - Le serveur fait une demande de fin, avec un drapeau FIN et une valeur y."
regles_fin += "\n4 - Le client répond avec un drapeau ACK de valeur x + 1."

regles ={0:regles_connexion,
         1:regles_connexion,
         2:regles_connexion,
         3:regles_echange,
         4:regles_echange,
         5:regles_echange,
         6:regles_fin,
         7:regles_fin,
         8:regles_fin,
         9:regles_fin,}

# GUI TKINTER
fenetre = tk.Tk()
fenetre.title("Serveur")
fenetre.configure(background='white')
largeur_ecran = fenetre.winfo_screenwidth()
hauteur_ecran = fenetre.winfo_screenheight()
b_lancement = tk.Button(fenetre, text = "", command = None)
b_quitter = tk.Button(fenetre, text = "Quitter", command = None)
b_envoyer = tk.Button(fenetre, text = "Envoyer des données", command = None)
b_effacer = tk.Button(fenetre, text = "Effacer entrée", command = None)
b_message = tk.Button(fenetre)
b_regles = tk.Button(fenetre, text = "Afficher les règles", command = None)
labels_co_s = [tk.Label(fenetre, text = "serveur") for i in range(25)]
labels_co_f = [tk.Label(fenetre, text = " "*21) for i in range(25)]
labels_co_c = [tk.Label(fenetre, text = "client") for i in range(25)]
labels_flags = [tk.Label(fenetre, text ="", bg = "lightgrey", width = 7) for i in range(6)]
labels_bouts = [tk.Entry(fenetre, bg = "lightgrey", width = 15) for i in range(6)]
entree = tk.Entry(fenetre, state ="disabled")
entree_msg = tk.Entry(fenetre, width = 60)
c_1 = tk.Label(fenetre, text = "")
c_2 = tk.Label(fenetre, text = "")
c_3 = tk.Label(fenetre, text ="Bouts de message envoyés :")
c_4 = tk.Label(fenetre, text ="Message à envoyer :")
c_5 = tk.Label(fenetre, text ="Score :")
c_6 = tk.Label(fenetre, text ="100")
c_7 = tk.Label(fenetre, text = "")
c_8 = tk.Label(fenetre, text = "")
c_9 = tk.Label(fenetre, text = "")
sb = tk.Scrollbar(fenetre, orient = "vertical")

sb.grid(row=0, column=13, rowspan = 25, sticky = "ns")
b_lancement.grid(row = 13, column = 0, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
b_envoyer.grid(row = 13, column = 1, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
b_effacer.grid(row = 13, column = 2, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
b_message.grid(row = 13, column = 3, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
b_regles.grid(row = 13, column = 4, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
b_quitter.grid(row = 15, column = 0, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
c_1.grid(row = 0, column = 0, columnspan = 5, padx = 2, pady = 2,
                                sticky = "w")
c_2.grid(row = 1, column = 0, columnspan = 2, padx = 2, pady = 2,
                                sticky = "w")
c_3.grid(row = 2, column = 0, columnspan = 2, padx = 2, pady = 2,
                                sticky = "w")
c_4.grid(row = 8, column = 0, columnspan = 2, padx = 2, pady = 2,
                                sticky = "w")
c_5.grid(row = 11, column = 0, columnspan = 1, padx = 2, pady = 2,
                                sticky = "E")
c_6.grid(row = 11, column = 1, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
entree.grid(row = 1, column = 2, columnspan = 3, padx = 2, pady = 2,
                                sticky = "w")
entree_msg.grid(row = 9, column = 0, columnspan = 5, padx = 2, pady = 2,
                                sticky = "w")
for i in range(25):
    labels_co_s[i].grid(row = i, column = 10, columnspan = 1, padx = 2, pady = 2)
    labels_co_f[i].grid(row = i, column = 11, columnspan = 1, padx = 2, pady = 2)
    labels_co_c[i].grid(row = i, column = 12, columnspan = 1, padx = 2, pady = 2)
for i in range(6):
    labels_flags[i].grid(row = i%3 + 3, column = (i//3) * 2, columnspan = 1, padx = 2, pady = 2, sticky = "E")
    labels_bouts[i].grid(row = i%3 + 3, column = (i//3) * 2 + 1, columnspan = 1, padx = 2, pady = 2, sticky = "W")
    #labels_bouts[i].insert(0, "abcdef")

# Variables globales (:-/) pour l'interface graphique
i_echange = 0
i_labels_bouts = 0
labels_bouts_serveur = [i for i in range(6)]
labels_bouts_client = labels_bouts_serveur
shuffle(labels_bouts_client)

def afficher_regles(jeu):
    texte_regles = regles[serveur.jeu.phase_nb]
    fenetre_fille = tk.Toplevel()      # creation de la fenetre fille
    fenetre_fille.grab_set()            # qui bloque la fenetre mere
    c_f1 = tk.Label(fenetre_fille, text = texte_regles, anchor = "w", justify = "left")
    c_f1.pack()
    jeu.score -= 1
    c_6.config(text = str(jeu.score))

def maj_gui(jeu):
    global i_labels_bouts, labels_bouts_client, i_echange
    
    # Mise à jour des échanges client-serveur
    chaine_drapeaux = ""
    for flag in jeu.drapeaux :
        chaine_drapeaux += str(flag) + " " + str(jeu.drapeaux[flag]) + " "
    chaine_drapeaux = chaine_drapeaux[:-1]
    nb_tirets = (21 - len(chaine_drapeaux))//2
    if jeu.phase_nb in jeu.PHASES_CLIENT : 
        chaine_drapeaux = "<" + "-"*(nb_tirets - 1) + chaine_drapeaux + "-"*nb_tirets
    else :
        chaine_drapeaux = "-"*nb_tirets + chaine_drapeaux + "-"*(nb_tirets - 1) + ">"
    labels_co_s[i_echange].configure(bg = "blue", fg = "white")
    labels_co_c[i_echange].configure(bg = "green", fg = "white")
    labels_co_f[i_echange].configure(text = chaine_drapeaux)
    i_echange += 1
    
    # Mise à jour des bouts de messages échangés en phase 3 (envoi de données)
    if jeu.phase_nb == 3 :
        bout = jeu.bouts_msg[jeu.indice_bout]
        chaine_seq = "SEQ " + str(jeu.drapeaux["SEQ"])
        if jeu.client :
            i = labels_bouts_client[i_labels_bouts]
        else :           
            i = i_labels_bouts
        i_labels_bouts += 1
        labels_flags[i].configure(text = chaine_seq)
        labels_bouts[i].insert(0, bout)
    
    # Vérification finale du message / fin du jeu
    if jeu.phase_nb == 9 and jeu.client :
        b_message.configure(state = "normal", command = final_test)
        entree_msg.configure(state = "normal")
        c_2.configure(text = "Fin des échanges\nReconstituez le message")
        entree.configure(state = "disabled")
    if jeu.phase_nb == 8 and not jeu.client :
        c_2.configure(text = "Fin des échanges")
        entree.configure(state = "disabled")
        jeu.t_fin = time()
        chaine, bonus = jeu.calcul_temps()
        c_7.configure(text = chaine)
        score_f = jeu.score + bonus
        c_8.grid(row = 12, column = 1, columnspan = 3, padx = 2, pady = 2,
                                sticky = "w")
        texte_score = "Score : " + str(jeu.score) + " + bonus temps : "
        texte_score += str(bonus) + " = score final " + str(score_f)
        c_8.configure(text = texte_score, borderwidth=3, relief="solid")
    
    c_6.config(text = str(jeu.score))
    # Mise à jour temps de jeu
    jeu.t_fin = time()
    chaine, bonus = jeu.calcul_temps()
    c_7.configure(text = chaine)
    

def change_msg(jeu):
    reponse = str(entree_msg.get())
    if len(reponse) < 40 or len(reponse) > 60 :
        entree_msg.delete("0", "end")
        entree_msg.insert(0, "Le message doit contenir entre 40 et 60 caractères")
        return
    jeu.msg = reponse.replace(" ", "_")
    c_1.config(text = "Message enregistré")
    return
        
def fenetre_debut_echange_serveur(chaine):
   b_lancement.configure(state = "disabled")
   b_envoyer.configure(state = "normal")
   texte = str(datetime.now())[10:-7]  + " - le client est connecté"
   c_2.config(text = "Entrez drapeaux et valeurs")
   entree.delete("0", "end")
   c_1.config(text = texte)
   for i in range(25) :
       labels_co_f[i].configure(text = "-"*21)
   c_7.grid(row = 11, column = 2, columnspan = 2, padx = 2, pady = 2,
                                sticky = "w")
   c_7.configure(text = chaine)
   
def definition_msg(jeu):
    # Seulement pour le serveur
    reponse = str(entree_msg.get())
    if len(reponse) < 40 or len(reponse) > 60 :
        entree_msg.delete("0", "end")
        entree_msg.insert(0, "Le message doit contenir entre 40 et 60 caractères")
        return
    jeu.msg = reponse.replace(" ", "_")
    c_1.config(text = "Message enregistré")
    entree_msg.delete("0", "end")
    entree_msg.insert(0,jeu.msg)
    # Découpage du message en tout petits chunks
    jeu.cut_msg()
    entree_msg.configure(state = "disabled") 
    b_envoyer.configure(state = "normal")
    b_lancement.configure(state = "normal")
    b_message.configure(state = "disabled")
    c_2.configure(text ="Démarrez le serveur\net donnez votre IP locale à votre partenaire")
    entree.configure(state = "normal")
    return

def obtention_IP(jeu, hostname, IPAddr):
    b_lancement.configure(text = "Obtenir l'IP\n(-10 au score)", 
                          command = lambda : affiche_IP(jeu, hostname, IPAddr))

def affiche_IP(jeu, hostname, IPAddr):
    texte = str(datetime.now())[10:-7] + " - Démarrage du serveur "+ hostname + " d'IP " + IPAddr
    c_1.config(text = str(texte))
    b_lancement.configure(state = "disabled")
    jeu.score = jeu.score - 10
    c_6.config(text = str(jeu.score))

# FONCTIONS DE JEU

class TCPGame():
    """
    Modèle pour le portocole TCP simplifié, entre autres :
        les drapeaux sont utilisés avec des numéros :-/
        connexion : drapeaux ACK et SYN + numéros de séquence et d'acquittement
                    sauf dernière poignée de main, création d'un drapeau ACQuittement
        Le numéro de séquence est crée lors de la première phase d'envoi de données par le serveur,
        et utilisé uniquement lors de la phase d'échange de données
    """
    def __init__(self):
        self.ERREURS = {0:"Pas d'erreur",
                        1:"Mauvaise valeur du drapeau",
                        2:"Drapeau manquant",
                        3:"Drapeau inexistant",
                        4:"Mauvais nombre de drapeaux",
                        5:"Mauvais choix de drapeau",
                        6:"Un drapeau n'a pas de valeur",
                        7:"Mauvais numéro de séquence",
                        8:"Autre chose qu'un nombre a été associé à un drapeau",
                        9:"Attendez de recevoir des données avant d'en envoyer",
                        10:"Valeurs des drapeaux comprises entre 100 et 900",
                        99:"erreur due au programme"}
        self.COUT_ERREURS = {0:0, 1:2, 2:3, 3:1, 4:2, 5:3, 6:3, 7:3, 8:1, 
                             9:1, 10: 0, 99:0}
        self.FLAGS = {"SYN", "ACK", "ACQ", "SEQ", "FIN"}
        self.PHASES = {0: {"SYN": None},
                       1: {"SYN": None, "ACK": None},
                       2: {"ACQ": None, "ACK": None},
                       3: {"SEQ": None, "ACK": None},
                       4: {"SEQ": None, "ACK": None},
                       5: {"SEQ": None, "ACK": None},
                       6: {"FIN": None},
                       7: {"ACK": None},
                       8: {"FIN": None},
                       9: {"ACK": None}}
        self.PHASES_NOMS = {0: "CONNEXION_CLIENT_DEMANDE",
                            1: "CONNEXION_SERVEUR_REPONSE",
                            2: "CONNEXION_CLIENT_REPONSE",
                            3: "DATA_SERVEUR_ENVOI",
                            4: "DATA_CLIENT_REPONSE",
                            5: "DATA_SERVEUR_REPONSE",
                            33: "DATA_SERVEUR_ENVOI",
                            44: "DATA_CLIENT_REPONSE",
                            55: "DATA_SERVEUR_REPONSE",
                            6: "FIN_CLIENT_DEMANDE",
                            7: "FIN_SERVEUR_REPONSE",
                            8: "FIN_SERVEUR_DEMANDE",
                            9: "FIN_CLIENT_REPONSE"}
        self.PHASES_CLIENT = (0, 2, 4, 6, 9)
        self.PHASES_SERVEUR = (1, 3, 5, 7, 8)
        self.client = True              # true si client False si serveur
        self.score = 100
        self.msg = "ceci_est_un_message_de_test_de_longueur_suffisante"
        self.phase_nb = 0
        self.drapeaux = {}
        # Numéro de séquence pour l'envoi des données
        self.num_seq = 0
        self.seq_first_time = True    # le numéro de séquence ne peut être choisi que lors du premier envoi
        # Bouts du message reçu
        self.indice_bout = 0
        self.bouts_msg = [None for i in range(6)]
        self.msg_compris = False
        # durée de jeu
        self.t_debut = 0
        self.t_fin = 0
        self.duree = 0

    def check_flags(self):
        """
        Teste la validité des drapeaux et de leurs valeurs
        Renvoie un numéro d'erreur (0 si pas d'erreur)
        """
        # CHEAT CODE :
        #print("reçus : ", self.drapeaux, "\nphase-nb : ", self.phase_nb,
        #    "attendus : ", self.PHASES[self.phase_nb])
        
        # Récupération des drapeaux et valeurs attendues
        drapeaux_attendus = self.PHASES[self.phase_nb]
        # Nombre de drapeaux/de valeurs correct ?
        if len(self.drapeaux) != len(drapeaux_attendus) :
            return 4
        # Les drapeaux sont bien suivis d'une valeur ?
        for flag in self.drapeaux :
            if self.drapeaux[flag] is None :
                return 6
            try :
                self.drapeaux[flag]= int(self.drapeaux[flag])
                if self.drapeaux[flag] < 100 or self.drapeaux[flag] > 900:
                    return 10
            except :
                return 8
        # Nom des drapeaux existant ?
        for flag in self.drapeaux :
            if flag not in self.FLAGS :
                return 3
        # Intitulé des drapeaux corrects ?
        for flag_a in drapeaux_attendus :
            if flag_a not in self.drapeaux :
                return 5
        # Valeurs des drapeaux correctes ?
        for flag in self.drapeaux :
            if drapeaux_attendus[flag] is not None and self.drapeaux[flag] != drapeaux_attendus[flag] :
                return 1
        # Numéro de séquence correct ?
        if self.phase_nb == 3 :
            if not self.seq_first_time and self.drapeaux['SEQ'] != self.PHASES[5]['SEQ'] + 1 :
                return 7

        return 0

    def appliquer_regles(self,bout_de_msg = None):
        # codage par drapeaux.get pour le client et sinon pour le serveur
        if self.phase_nb == 0:       #Envoyés par le client
            self.PHASES[0]['SYN'] = self.drapeaux.get('SYN')
            self.PHASES[1]['ACK'] = self.drapeaux.get('SYN') + 1   #phase du serveur
            self.PHASES[2]['ACQ'] = self.drapeaux.get('SYN') + 1
        elif self.phase_nb == 1:     #Envoyés par le serveur
            self.PHASES[1]['SYN'] = self.drapeaux['SYN']      #phase du serveur
            self.PHASES[2]['ACK'] = self.drapeaux['SYN'] + 1
        elif self.phase_nb == 2 :    #Envoyés par le client
            pass                # les self.drapeaux sont déjà complétés en phase 0 et 1
        elif self.phase_nb == 3 :    #Envoyés par le serveur
            if self.seq_first_time :        # and not self.client automatiquement
                self.num_seq == self.drapeaux['SEQ']
                self.seq_first_time = False
                self.PHASES[3]['SEQ'] = self.drapeaux['SEQ']      # phase du serveur
            self.PHASES[3]['ACK'] = self.drapeaux['ACK']      # phase du serveur
            self.PHASES[4]['SEQ'] = self.drapeaux['ACK']
            self.PHASES[4]['ACK'] = self.drapeaux['SEQ'] + len(bout_de_msg)
            self.PHASES[5]['ACK'] = self.drapeaux['ACK'] + len(bout_de_msg)
            self.PHASES[5]['SEQ'] = self.drapeaux['SEQ'] + len(bout_de_msg)
        elif self.phase_nb == 4 :    #Envoyés par le client
            pass                # les self.drapeaux sont déjà complétés en phase 3
        elif self.phase_nb == 5 :    #Envoyés par le serveur
             self.PHASES[3]['SEQ'] =  self.PHASES[5]['SEQ'] + 1
             self.PHASES[3]['ACK'] = None
        elif self.phase_nb == 6 :    #Envoyés par le client
            self.PHASES[6]['FIN'] = self.drapeaux.get('FIN')
            self.PHASES[7]['ACK'] = self.drapeaux.get('FIN') + 1   #phase du serveur
        elif self.phase_nb == 7 :    #Envoyés par le serveur
            pass                # les self.drapeaux sont déjà complétés en phase 6
        elif self.phase_nb == 8 :    #Envoyés par le serveur
            self.PHASES[8]['FIN'] = self.drapeaux['FIN']          #phase du serveur
            self.PHASES[9]['ACK'] = self.drapeaux['FIN'] + 1
        elif self.phase_nb == 9 :    #Envoyés par le client
            pass                # les drapeaux sont déjà complétés en phase 8

    def enter_the_flag(self, chaine):
        """
        Entrée des drapeaux pour envoi
        """
        self.drapeaux = {}
        chaine = chaine.split()

        # on extrait le (bout de) message reçu en phase 1 et 3 avant construction du
        # dictionnaire des drapeaux
        if self.phase_nb == 3 and len(chaine) == 5 and not self.client :
            self.bouts_msg[self.indice_bout] = chaine.pop(4)
        if self.phase_nb == 1 and len(chaine) == 5 and not self.client :
            self.msg = chaine.pop(4)
        # Construction du dictionnaire des drapeaux rentrés en deux étapes :
        # il peut y avoir une incohérence (pas de valeur pour le dernier drapeau)
        for i in range(0,len(chaine),2):
            self.drapeaux[chaine[i]] = None

        for i in range(1,len(chaine),2):
            self.drapeaux[chaine[i - 1]] = chaine[i]
            
        # On checke les self.ERREURS
        err_nb = self.check_flags()
        if err_nb == 0 :
            # On complète le dictionnaire des PHASES (valeurs attendues)
            # avec les règles
            if self.phase_nb == 3 :
                bout_de_msg = self.bouts_msg[self.indice_bout]
            else :
                bout_de_msg = None
            self.appliquer_regles(bout_de_msg)
            texte = str(datetime.now())[10:-7] + " - Envoi des drapeaux : " + str(chaine)
            if self.phase_nb == 3 and not self.client :
                texte = texte + " " + self.bouts_msg[self.indice_bout]
        else :
            self.score = self.score - self.COUT_ERREURS[err_nb]
            texte = str(datetime.now())[10:-7] + " - erreur : " + self.ERREURS[err_nb]
        return (err_nb, texte)

    def receive_flags(self, chaine):
        """
        Récupération des drapeaux et éventuellement des données
        La vérification de la validité du message a déjà été faite par l'expéditeur
        Il faut nénamoins enlever ce qui n'est pas drapeaux + valeurs
        """
        chaine = chaine.split()
        self.drapeaux = {chaine[0]:int(chaine[1])}
        if self.phase_nb >= 1 and self.phase_nb <= 5 :
            self.drapeaux[chaine[2]] = int(chaine[3])

        # En phase 1 le message à reconstituer est envoyé par le serveur
        if self.phase_nb == 1 and self.client :
            self.msg= chaine[4]
        # En phase 3 un bout du message est envoyé par le serveur
        bout_de_msg = ""
        if self.phase_nb == 3 and self.client :
            bout_de_msg= chaine[4]
            self.bouts_msg[self.indice_bout] = chaine[4]
            
        self.appliquer_regles(bout_de_msg)
        return

    def appel_regles(self):
        self.score = self.score - 1
        return None

    def check_send_ok(self) :
        # Vérifie si l'expéditeur est dans un tour où il a le droit d'expédier
        # Si oui renvoie True + "", si non renvoie False + msg d'erreur
        if self.client and self.phase_nb in self.PHASES_CLIENT : 
            return (True, "")
        elif not self.client and self.phase_nb in self.PHASES_SERVEUR :
            return (True, "")
        texte = str(datetime.now())[10:-7] + " - erreur : " + self.ERREURS[9]
        self.score = self.score - self.COUT_ERREURS[9]
        return (False, texte)
        #texte = "erreur de programme en phase : " + self.phase_nb
        #return (False, texte)
    
    def cut_msg(self):
        pas = len(self.msg)//6
        debut = 0
        fin = pas + randint(-2,2)
        for i in range(5):
            self.bouts_msg[i] = self.msg[debut:fin]
            debut = fin
            fin = fin + pas + randint(-2,2)
        self.bouts_msg[5] = self.msg[debut:]
        return

    def final_test(self, msg_final):
        # Teste si le client a bien compris le message reçu
        if msg_final == self.msg :
            self.msg_compris = True
            return True
        else :
            self.msg_compris = False
            self.score = self.score - 10
            return False
        
    def test_fin_envoi_msg(self):
        if self.phase_nb == 6 and self.indice_bout < len(self.bouts_msg) - 1 :
            self.indice_bout += 1
            self.phase_nb = 3
            
    def calcul_temps(self):
        self.duree = int(self.t_fin - self.t_debut)
        chaine ="temps de jeu : " + str(self.duree // 60) + " mn " + str(self.duree % 60) + "s"
        if self.client :
            temps_en_plus = 45
        else :
            temps_en_plus = 0
        temps = self.duree - 300 - temps_en_plus
        k = log(100)/600
        bonus = floor(100*exp(-k*temps))
        return chaine, bonus
           
# SERVEUR

class Serveur:
    def __init__(self):
        self.s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.jeu = TCPGame()
        self.jeu.client = False
        
    def connect(self):
        self.s.bind(("", 12346))
        self.s.listen(10)
        hostname = socket.gethostname()
        IPAddr = socket.gethostbyname(hostname)
        texte = str(datetime.now())[10:-7] + " - Démarrage du serveur "+ hostname # + " d'IP " + IPAddr
        c_1.config(text = str(texte))
        obtention_IP(self.jeu, hostname, IPAddr)
        try :
            c, addr = self.s.accept()
            self.client = c
            texte = str(datetime.now())[10:-7] + " - Connection du client d'adresse " + str(addr)
            b_lancement.configure(state = "disabled")
            c_1.config(text = texte)
            c_2.config(text = "Entrez drapeaux et valeurs")
            self.jeu.phase_nb = 0
            self.jeu.t_debut = time()
            self.jeu.t_fin = time()
            chaine, bonus = self.jeu.calcul_temps()
            fenetre_debut_echange_serveur(chaine)
        except :
            print("connexion client ratée")
            pass
          
        def f():
            while True:
                data = self.client.recv(1024).decode()
                """
                if len(data) == 0:
                    print("rien reçu")
                    destroy()
                    pass
                
                else:
                """
                now = str(datetime.now())[10:-7]
                texte = now + " - Le serveur reçoit les données du client : " + data
                c_1.config(text = texte)
                self.jeu.receive_flags(data)
                maj_gui(self.jeu)
                self.jeu.phase_nb += 1

        t1_2 = threading.Thread(target=f)
        #t1_2.daemon = True
        t1_2.start()
            
    def send(self):
        tour_ok, texte = self.jeu.check_send_ok()
        if tour_ok:
            reponse = str(entree.get())
            
            # On rajoute en phase 1 : le message à reconstituer par le client
            #            en phase 3 : les bouts de messages envoyés
            if self.jeu.phase_nb == 3:
                bout = self.jeu.bouts_msg[self.jeu.indice_bout]
                reponse = reponse + " " + bout
                
            if self.jeu.phase_nb == 1 :
                reponse = reponse + " " + self.jeu.msg
            (err_nb, texte) = self.jeu.enter_the_flag(reponse)
            if err_nb == 0 :
                entree.delete("0", "end")
                try:
                    self.client.sendall(bytes(reponse.encode("utf-8")))
                    if self.jeu.phase_nb == 3 :
                        dat = texte.split()[:-1]
                        texte = " ".join(dat)
                    maj_gui(self.jeu)
                    self.jeu.phase_nb += 1
                    self.jeu.test_fin_envoi_msg()   # envoi incomplet -> retour en phase 3 ?
                except BrokenPipeError:
                    texte = str(datetime.now())[10:-7] + " - Erreur, le client est déconnecté"
                    self.s.close()
                    
        c_1.config(text = texte)
        c_6.config(text = str(self.jeu.score))
            

serveur = Serveur()

def connect():
    t1 = threading.Thread(target = serveur.connect)
    t1.start()

def send():
    t2 = threading.Thread(target = serveur.send)
    t2.start()

def clear():
    entree.delete("0", "end")

def destroy():
    serveur.s.close()
    fenetre.destroy()

# MAIN

if __name__ == "__main__":
    entree_msg.insert(0, str(serveur.jeu.msg))
    entree_msg.bind("<Return>", lambda event : change_msg(serveur.jeu))
    b_lancement.configure(text = "Demarrer le serveur", command = connect, 
                          state = "disabled")
    b_envoyer.configure(command = send, state = "disabled")
    b_effacer.configure(command = clear)
    b_quitter.configure(command = destroy)
    b_regles.configure(command = lambda:afficher_regles(serveur.jeu))
    c_1.config(text = "Serveur non démarré")
    b_message.configure(state = "normal", text = "Cliquez ici si le message vous convient\nsinon changez-le",
                        command = lambda:definition_msg(serveur.jeu))
    t0 = threading.Thread(target = fenetre.mainloop)
    t0.run()
    
    
